
#ifndef DESC_TABLES_H
#define DESC_TABLES_H

#include <stdint.h>

typedef struct
{
	uint16 limitLow;
	uint16 baseLow;
	uint8 baseMiddle;
	uint8 access;
	uint8 granularity;
	uint8 baseHigh;
}__attribute__((packed)) GDTEntry;

typedef struct
{
	uint16 limit;
	uint32 base;
}__attribute__((packed)) GDTPtr;

typedef struct
{
	uint16 baseLow;
	uint16 sel;
	uint8 always0;
	uint8 flags;
	uint16 baseHigh;
}__attribute__((packed)) IDTEntry;

typedef struct
{
	uint16 limit;
	uint32 base;
}__attribute__((packed))IDTPtr;

typedef struct
{
	uint32 previousTSS; // We don't use hardware task switching, so this isn't used.
	// Standard registers
	uint32 esp0; // Kernel mode stack pointer
	uint32 ss0; // Kernel mode stack segment
	uint32 esp1; // Not used..
	uint32 ss1;
	uint32 esp2;
	uint32 ss2;
	uint32 cr3;
	uint32 eip;
	uint32 eflags;
	uint32 eax;
	uint32 ebx;
	uint32 esp;
	uint32 ebp;
	uint32 esi;
	uint32 edi;
	uint32 es;
	uint32 cs;
	uint32 ss;
	uint32 ds;
	uint32 fs;
	uint32 gs;
	uint32 ldt;
	uint16 trap;
	uint16 iomapBase;
}__attribute__((packed)) _TSSEntry;

#ifdef __cplusplus
extern "C"
{
#endif
	
	void initDT(void);
	
	extern void isr0();
	extern void isr1();
	extern void isr2();
	extern void isr3();
	extern void isr4();
	extern void isr5();
	extern void isr6();
	extern void isr7();
	extern void isr8();
	extern void isr9();
	extern void isr10();
	extern void isr11();
	extern void isr12();
	extern void isr13();
	extern void isr14();
	extern void isr15();
	extern void isr16();
	extern void isr17();
	extern void isr18();
	extern void isr19();
	extern void isr20();
	extern void isr21();
	extern void isr22();
	extern void isr23();
	extern void isr23();
	extern void isr24();
	extern void isr25();
	extern void isr26();
	extern void isr27();
	extern void isr28();
	extern void isr29();
	extern void isr30();
	extern void isr31();
#ifdef __cplusplus
}
#endif

#endif